/* 
 * seta43
 * Juan Galaz
 * http: / / seta43.duckdns.org
 * http: / / seta43.blogspot.com 
 * 2021
 * Uso de librería 
 * searle.x10host.com/MonitorKeyboard
*/

#include <Wire.h>

#include <VirtualWire.h>
#include "DHT.h"

#define DHTPIN 3     // what pin we're connected to
//#define DHTTYPE DHT11   // DHT 11
#define DHTTYPE DHT22   // DHT 22  (AM2302)
//#define DHTTYPE DHT21   // DHT 21 (AM2301)
DHT dht(DHTPIN, DHTTYPE);



float h,t;
int hi,ti;
int t1,t2;

char cadena[100];
char titulo1[]="seta43.duckdns.org";
char titulo2[]="searle.x10host.com/MonitorKeyboard";

//_________________________

#define ADD_I2C  1


  int z=64;

void setup()
   {
    Wire.begin();        // unirse al bus i2c como master
    Serial.begin(9600);  // configurar monitor serie a 9600

    dht.begin();

    vMODO(0,1,1);
    vCLS();
    
    sendI2C(3); //Cursor OFF
    sendI2C_2(2,0x5F); //Define caracter de cursor

   }
   
void loop() 
{
  
    h = dht.readHumidity();
    t = dht.readTemperature();

      if (isnan(t) || isnan(h))
        {
          sprintf(cadena," Failed to read from DHT");
          Serial.println(cadena); 
          sendString(cadena); 
        }
      else
        {      
          hi=h;
          ti=t*10;
         
          t1=t;
          t2=ti-t1*10;
    
          sprintf(cadena,"Humedad= %2d%c   Temperatura= %i.%i %cC",hi,37,t1,t2,0xF8);
          Serial.println(cadena); 
          vCLS();

          delay(300);
          sendString(cadena); 
          vENTER();

          delay(500);
          vLOCATE(0,4);
          sendString(titulo1);

          delay(500);
          vLOCATE(0,8);
          sendString(titulo2);

          delay(500);
          vLOCATE(10,15);
          sendString("SETA43");

        }

         
  delay(2000); 
}


//___Comandos______

void vPLOT(bool p,unsigned char x,unsigned char y)
{
  if(p==1)
    {
      Wire.beginTransmission(ADD_I2C); 
      Wire.write(5);
      Wire.write(x);
      Wire.write(y);
      Wire.endTransmission();     
    }
    else
    {
      Wire.beginTransmission(ADD_I2C); 
      Wire.write(6);
      Wire.write(x);
      Wire.write(y);
      Wire.endTransmission();   
    }
}


void vGRAFI(void)
  {
    sendI2C_2(24,128);
  }
  
void vMODO(bool numero,bool negro,bool doble) // 40/80 - activo - doble
    {
      unsigned char tipo;
        tipo=numero*1+negro*2+doble*4;
        sendI2C_2(24,tipo); 
    }


void vCLS(void)
    {
      sendI2C(12); //borrar
      delay(100);
    }

void vENTER(void)
    {
      sendI2C(13);
      delay(60); 
      sendI2C(10); 
      delay(60); 
    }

void vLOCATE(unsigned char x,unsigned char y)
    {
      sendI2C_2(15,y);  
      delay(10);
      sendI2C_2(14,x); 
      delay(10);
      
    }
void sendI2C(char c)
    {
      Wire.beginTransmission(ADD_I2C); // Comenzar a comunicarse con esclavo #23
      Wire.write(c);
      Wire.endTransmission();     // Finalizar comunicación
    }

void sendI2C_2(char a,char b)
    {
      Wire.beginTransmission(ADD_I2C); // Comenzar a comunicarse con esclavo #23
      Wire.write(a);
      Wire.write(b);
      Wire.endTransmission();     // Finalizar comunicación
    }


void sendString(unsigned char *d)
    { 
      while(*d>31)
        {
          sendI2C(*d);
          d++;
          delay(1);
        }
    }

    
